use std::net::{TcpListener, TcpStream};
use std::os::unix::net::{UnixListener, UnixStream};
use std::io::prelude::*;
use crate::conf;
use std::sync::{Arc, RwLock};

pub fn server_conf(conf: Arc<RwLock<conf::Config>>){
    let listener = UnixListener::bind("mineproxy").unwrap();


    for stream in listener.incoming() {
        match stream{
        Ok(s) => process_reques(s, conf.clone()),
        Err(_e) => println!("{}",_e),
        }
    }

}

fn process_reques(mut stream: UnixStream, conf: Arc<RwLock<conf::Config>>) {
    let mut buf: [u8; 256] = [1; 256];
    match stream.read(&mut buf){
        Ok(len) => check_state(&mut buf, len, conf),
        Err(e) => println!("Fatal: {}", e),
    }
}

fn check_state(buf: &mut [u8; 256], len: usize, conf: Arc<RwLock<conf::Config>>) {
    let var = String::from_utf8(buf[0 .. len].to_vec()).unwrap();
    match var.as_str(){
        "add" => println!("entra"),
        "dell" => println!("del"),
        "mod" => println!("mod"),
        _=> println!("no recognice option: {}", var),
    }
}
